

curvefitdxdy<- function(dx,y,dy){
  x<- dx 
  y1<-y
  y<-dy
  results<-data.frame()
  predictions<-NULL
  
  #Linear Models
  m1<-NULL
  m1<- tryCatch(gnls(y~ a+ b*x , start= c(a=0, b=1)), error=function(e) NULL)
  if(!is.null(m1)){
    dyEst<- predict(m1)
    yEst<- lapply(1:(length(dyEst)), function(i) sum(dyEst[1:i]))
    yEst<- apply( cbind( yEst ) , 1 , unlist ) +y1[1]
    yEst<- c(y1[1],yEst)
    results<- rbind.fill(results, data.frame(cbind(rbind(m1$coefficients),Mape=100*sum(abs((y1-yEst)/y1))/length(y1), Sigma=sqrt(sum((y1-yEst)^2)/length(y1)), Method= "LinFunc", Function="dy~ a+ b*x", Model= "m1", Isnull=is.null(m1) ) ))
    predictions<- cbind(predictions, M1=yEst)}
  
  m2<-NULL
  m2<- tryCatch(lm(y~ x), error=function(e) NULL)
  if(!is.null(m2)){
    dyEst<- predict(m2)
    yEst<- lapply(1:(length(dyEst)), function(i) sum(dyEst[1:i]))
    yEst<- apply( cbind( yEst ) , 1 , unlist ) +y1[1]
    yEst<- c(y1[1],yEst)
    results<- rbind.fill(results, data.frame(cbind(rbind(m2$coefficients),Mape=100*sum(abs((y1-yEst)/y1))/length(y1), Sigma=sqrt(sum((y1-yEst)^2)/length(y1)), Method= "LinFunc", Function="dy~ a+ b*x", Model= "m2", Isnull=is.null(m2) ) ))
    predictions<- cbind(predictions, M2=yEst)}
  
  #Exponential and Sshaped Models
  m3<- NULL
  logy<- log(y)
  m3<- tryCatch(gnls(logy~ a+b*x, start=c(a=0, b=1)), error=function(e) NULL)
  if(!is.null(m3)){
    dyEst<- exp(predict(m3))
    yEst<- lapply(1:(length(dyEst)), function(i) sum(dyEst[1:i]))
    yEst<- apply( cbind( yEst ) , 1 , unlist ) +y1[1]
    yEst<- c(y1[1],yEst)
    results<- rbind.fill(results, data.frame(cbind(rbind(m3$coefficients),Mape=100*sum(abs((y1-yEst)/y1))/length(y1), Sigma=sqrt(sum((y1-yEst)^2)/length(y1)), Method= "ExpFunc", Function="logdy~ a+b*x", Model= "m3", Isnull=is.null(m3)  ) ))
    predictions<- cbind(predictions, M3=yEst)}
  
  m7<- NULL
  m7<- tryCatch(nls(y~ SSlogis(x, Asym, xmid, scal)), error=function(e) NULL)
   if(!is.null(m7)){
    dyEst<- predict(m7)
    yEst<- lapply(1:(length(dyEst)), function(i) sum(dyEst[1:i]))
    yEst<- apply( cbind( yEst ) , 1 , unlist ) +y1[1]
    yEst<- c(y1[1],yEst)
    results<- rbind.fill(results, data.frame(cbind(rbind(coef(m7)),Mape=100*sum(abs((y1-yEst)/y1))/length(y1), Sigma=sqrt(sum((y1-yEst)^2)/length(y1)), Method= "SShaped", Function="dy~ SSlogis(x, Asym, xmid, scal)", Model= "m7", Isnull=is.null(m7)  ) ))
    predictions<- cbind(predictions, M7=yEst)}
  
  m8<- NULL
  m8<-  tryCatch(nls(y~ SSasymp(x, Asym, R0, lrc)), error=function(e) NULL)
   if(!is.null(m8)){
    dyEst<- predict(m8)
    yEst<- lapply(1:(length(dyEst)), function(i) sum(dyEst[1:i]))
    yEst<- apply( cbind( yEst ) , 1 , unlist ) +y1[1]
    yEst<- c(y1[1],yEst)
    results<- rbind.fill(results, data.frame(cbind(rbind(coef(m8)),Mape=100*sum(abs((y1-yEst)/y1))/length(y1), Sigma=sqrt(sum((y1-yEst)^2)/length(y1)), Method= "SShaped", Function="dy~ SSasymp(x, Asym, R0, lrc)", Model= "m8", Isnull=is.null(m8)  ) ))
    predictions<- cbind(predictions, M8=yEst)}
  

  m11<- NULL
  logy<- log(-y)
  m11<- tryCatch(gnls(logy~ a+b*x, start=c(a=0, b=1)), error=function(e) NULL)
  if(!is.null(m11)){
    dyEst<- -exp(predict(m11))
    yEst<- lapply(1:(length(dyEst)), function(i) sum(dyEst[1:i]))
    yEst<- apply( cbind( yEst ) , 1 , unlist ) +y1[1]
    yEst<- c(y1[1],yEst)
    results<- rbind.fill(results, data.frame(cbind(rbind(m11$coefficients),Mape=100*sum(abs((y1-yEst)/y1))/length(y1), Sigma=sqrt(sum((y1-yEst)^2)/length(y1)), Method= "ExpFunc", Function="log-dy~ a+b*x", Model= "m11", Isnull=is.null(m11)  ) ))
    predictions<- cbind(predictions, M11=yEst)}
  
  if(!is.null(m7))
  {
    m13<- NULL
    m13<- tryCatch( gnls(y ~ Asym/(1+exp((xmid-x)/scal)), start = coef(m7)), error=function(e) NULL)
    if(!is.null(m13)){
      dyEst<- predict(m13)
      yEst<- lapply(1:(length(dyEst)), function(i) sum(dyEst[1:i]))
      yEst<- apply( cbind( yEst ) , 1 , unlist ) +y1[1]
      yEst<- c(y1[1],yEst)
      results<- rbind.fill(results, data.frame(cbind(rbind(m13$coefficients),Mape=100*sum(abs((y1-yEst)/y1))/length(y1), Sigma=sqrt(sum((y1-yEst)^2)/length(y1)), Method= "SShaped", Function="dy ~ Asym/(1+exp((xmid-x)/scal)", Model= "m13", Isnull=is.null(m13)  ) ))
      predictions<- cbind(predictions, M13=yEst)}
  }
  
  m16<- NULL
  m16<- tryCatch( gnls(y ~max(y)/(1+exp((xmid-x)/scal)), start = c(xmid=1, scal=1)), error=function(e) NULL)
  if(!is.null(m16)){
    dyEst<- predict(m16)
    yEst<- lapply(1:(length(dyEst)), function(i) sum(dyEst[1:i]))
    yEst<- apply( cbind( yEst ) , 1 , unlist ) +y1[1]
    yEst<- c(y1[1],yEst)
    results<- rbind.fill(results, data.frame(cbind(rbind(m16$coefficients), Mape=100*sum(abs((y1-yEst)/y1))/length(y1), Sigma=sqrt(sum((y1-yEst)^2)/length(y1)), Method= "SShaped", Function="dy ~ max(dy)/(1+exp((xmid-x)/scal)", Model= "m16", Isnull=is.null(m16)  ) ))
    predictions<- cbind(predictions, M16=yEst)}
  
  m17<- NULL
  m17<- tryCatch( gnls(y ~max(y)-(max(y)-min(y))/(1+exp((xmid-x)/scal)), start = c(xmid=1, scal=1)), error=function(e) NULL)
  if(!is.null(m17)){
    dyEst<- predict(m17)
    yEst<- lapply(1:(length(dyEst)), function(i) sum(dyEst[1:i]))
    yEst<- apply( cbind( yEst ) , 1 , unlist ) +y1[1]
    yEst<- c(y1[1],yEst)
    results<- rbind.fill(results, data.frame(cbind(rbind(m17$coefficients),Mape=100*sum(abs((y1-yEst)/y1))/length(y1), Sigma=sqrt(sum((y1-yEst)^2)/length(y1)), Method= "SShaped", Function="dy ~max(dy)-(max(dy)-min(dy))/(1+exp((xmid-x)/scal))", Model= "m17", Isnull=is.null(m17)  ) ))
    predictions<- cbind(predictions, M17=yEst)}
  
  m18<- NULL
  m18<- tryCatch( gnls(y ~min(y) +(max(y)-min(y))/(1+exp((xmid-x)/scal)), start = c(xmid=1, scal=1)), error=function(e) NULL)
  if(!is.null(m18)){
    dyEst<- predict(m18)
    yEst<- lapply(1:(length(dyEst)), function(i) sum(dyEst[1:i]))
    yEst<- apply( cbind( yEst ) , 1 , unlist ) +y1[1]
    yEst<- c(y1[1],yEst)
    results<- rbind.fill(results, data.frame(cbind(rbind(m18$coefficients),Mape=100*sum(abs((y1-yEst)/y1))/length(y1), Sigma=sqrt(sum((y1-yEst)^2)/length(y1)), Method= "SShaped", Function="dy ~ min(dy) +(max(dy)-min(dy))/(1+exp((xmid-x)/scal)", Model= "m18", Isnull=is.null(m18)  ) ))
    predictions<- cbind(predictions, M18=yEst)}
  
  
  
  results<- results[which(results$Isnull == FALSE),]
  results3<-results
  predictions3<-predictions
  output3<-list(results3, predictions3)
  return (output3)
}